/**
 * controllers/index.js
 * */

"use strict";

var controller = require('./controller.js')

module.exports = class {

    constructor(config, paths) {
        this.config = config;
        this.paths = paths;
        this.controller = new controller(config, paths)
    }

    sets(values){
        for(var key in values){
            this[key] = values[key]
        }
    }

    setView(view){
        this.view = view;
    }

    setModel(model){
        this.model = model;
    }

    setLooger(looger){
        this.looger = looger;
    }

    load() {
        this.files = this.controller.load().files
        return this;
    }

    init(req, res){
        var control = new controller(this.config, this.paths)
        if(this.files){
            control.files = this.files;
        }

        control.model = this.model
        control.view = new this.view({config: this.config, paths: this.paths})
        control.logger = this.logger

        if(req && res){
            return control.http(req, res);
        }

        return control;
    }

}
